<?php

/*
Plugin Name: Peter's Date Countdown
Plugin URI: http://www.theblog.ca
Description: Display a countdown of important dates
Version: 1.1
Author: Peter Keung
Author URI: http://www.theblog.ca/?p=41
Change Log:
2006-08-10  The first version.
2006-08-14  New feature: sort the countdowns by date. Also, tweaked rounding of dates.
*/

// You shouldn't have to edit below this line!

function countdown_manage() {
if (isset($_GET['sort'])) {
require "../wp-content/plugins/datecountdowndates.php";
$howmanydates = count($importantdate);
for ($i = 0; $i < $howmanydates; $i = $i + 1) {
$month = $importantdate[$i][1];
$day = $importantdate[$i][2];
$year = $importantdate[$i][3];
$importantdate[$i]['date'] = mktime(0,0,0,$month,$day,$year);
}
function cmp ($a, $b) {
if ( $a['date'] < $b['date'] ) {
return -1;
}
if ( $a['date'] > $b['date'] ) {
return 1;
}
return 0;
}
usort($importantdate, "cmp");
$line[] = "<?";
$i = 0;
while ($i < $howmanydates) {
$itemname = $importantdate[$i][0];
$itemday = $importantdate[$i][2];
$itemmonth = $importantdate[$i][1];
$itemyear = $importantdate[$i][3];
$itemfinished = $importantdate[$i][4];
$line[] = "$" . "importantdate[$i]=array(\"$itemname\", $itemmonth, $itemday, $itemyear, \"$itemfinished\");";
++$i;
}
$line[] = "?>";
$mystring = implode("\n", $line);
$open = fopen("../wp-content/plugins/datecountdowndates.php", "w");
fwrite($open, $mystring);
fclose($open);
}
if (isset($_GET['deletedate'])) {
$goback = $_SERVER['HTTP_REFERER'];
require "../wp-content/plugins/datecountdowndates.php";
$line[] = "<?";
$howmanydates = count($importantdate);
$modi = 0;
for ($i = 0; $i < $howmanydates; $i = $i + 1) {
if ($i == $_GET['deletedate']) {
continue;
}
$itemname = $importantdate[$i][0];
$itemmonth = $importantdate[$i][1];
$itemday = $importantdate[$i][2];
$itemyear = $importantdate[$i][3];
$itemfinished = $importantdate[$i][4];
$line[] = "$" . "importantdate[$modi]=array(\"$itemname\", $itemmonth, $itemday, $itemyear, \"$itemfinished\");";
$modi = $modi + 1;
}
$line[] = "?>";
$mystring = implode("\n", $line);
$open = fopen("../wp-content/plugins/datecountdowndates.php", "w");
fwrite($open, $mystring);
fclose($open);
print "<div class=\"wrap\">\n<p>Date deleted!</p>\n<p><a href=\"$goback\">Back</a><p>\n</div>";
}
else {
if ($_POST['submit']) {
$line[] = "<?";
$howmanydates = count($_POST['itemname']);
$i = 0;
while ($i < $howmanydates) {
$itemname = $_POST['itemname'][$i];
$itemday = $_POST['itemday'][$i];
$itemmonth = $_POST['itemmonth'][$i];
$itemyear = $_POST['itemyear'][$i];
$itemfinished = $_POST['itemfinished'][$i];
$line[] = "$" . "importantdate[$i]=array(\"$itemname\", $itemmonth, $itemday, $itemyear, \"$itemfinished\");";
++$i;
if ($i + 1 == $howmanydates) {
if ($_POST['itemname'][$i] == "" or $_POST['itemday'][$i] == "" or $_POST['itemmonth'][$i] == "" or $_POST['itemyear'][$i] == "")
break;
}
}
$line[] = "?>";
$mystring = implode("\n", $line);
$open = fopen("../wp-content/plugins/datecountdowndates.php", "w");
fwrite($open, $mystring);
fclose($open);
}
require "../wp-content/plugins/datecountdowndates.php";
	?>
	<div class="wrap">
	<h2>Date Countdown</h2>
<h3>Current Countdowns:</h3>
<p><strong><a href="<? print $_SERVER['REQUEST_URI']; ?>&sort">Sort by date, ascending</a></strong></p>
<p><font color="red">Note: to delete an item, click on the red X, or simply replace the info with a new item!</font></p>
<form name="currentcountdowns" method="post" action="<?php echo $_SERVER['PHP_SELF'];?>?page=datecountdown.php">
<?
$howmanydates = count($importantdate);
$i = 0;
while ($i < $howmanydates) {
?>
<p><strong><a href="<? print $_SERVER['REQUEST_URI']; ?>&deletedate=<? print $i; ?>"><font color="red">X</font></a></strong>&nbsp;&nbsp;Name: <input type="text" name="<? print "itemname[$i]"; ?>" size="30" maxlength="45" value="<? print stripslashes($importantdate[$i][0]); ?>" /> Month: <input type="text" name="<? print "itemmonth[$i]"; ?>" size="2" maxlength="2" value="<? print $importantdate[$i][1]; ?>" /> Day: <input type="text" name="<? print "itemday[$i]"; ?>" size="2" maxlength="2" value="<? print $importantdate[$i][2]; ?>" /> Year: <input type="text" name="<? print "itemyear[$i]"; ?>" size="4" maxlength="4" value="<? print $importantdate[$i][3]; ?>" /> <br />Text when finished: <input type="text" name="<? print "itemfinished[$i]"; ?>" size="30" maxlength="45" value="<? print stripslashes($importantdate[$i][4]); ?>" /></p> 
	<?php
++$i;
}
?>
<h3>Add a new countdown</h3>
<p>Name: <input type="text" name="<? print "itemname[$i]"; ?>" size="30" maxlength="30" /> Month: <input type="text" name="<? print "itemmonth[$i]"; ?>" size="2" maxlength="2" /> Day: <input type="text" name="<? print "itemday[$i]"; ?>" size="2" maxlength="2" /> Year: <input type="text" name="<? print "itemyear[$i]"; ?>" size="4" maxlength="4" /> <br />Text when finished: <input type="text" name="<? print "itemfinished[$i]"; ?>" size="30" maxlength="30" /></p>
<input name="submit" type="submit" value="Update" />
<?
}
}

function countdown_callit() {
require "wp-content/plugins/datecountdowndates.php";
$howmanydates = count($importantdate);
$i = 0;
while ($i < $howmanydates) {
countdown_execute(stripslashes($importantdate[$i][0]), $importantdate[$i][1], $importantdate[$i][2], $importantdate[$i][3], stripslashes($importantdate[$i][4]));
++$i;
}
}

function countdown_execute($event,$month,$day,$year,$finished) {
// subtract desired date from current date and give an answer in terms of days
$remain = ceil((mktime(0,0,0,$month,$day,$year) - time()) / 86400);
// show the number of days left
if ($remain > 0) {
if ($remain == 1) {
print "<p><strong>$remain</strong> more sleep until $event</p>\n";
}
else {
print "<p><strong>$remain</strong> more sleeps until $event</p>\n";
}
}
// if the event has arrived, say so!
else {
print "<p>$finished</p>\n";
}
}

function datecountdown_adminmenu(){
	add_management_page('Date Countdown', 'Date Countdown', 9, 'datecountdown.php', 'countdown_manage');
}

add_action('admin_menu','datecountdown_adminmenu',1);
?>